# AxisAlgorithms

[![CI](https://github.com/timholy/AxisAlgorithms.jl/actions/workflows/ci.yml/badge.svg)](https://github.com/timholy/AxisAlgorithms.jl/actions/workflows/ci.yml)
[![codecov](https://codecov.io/gh/timholy/AxisAlgorithms.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/timholy/AxisAlgorithms.jl)

AxisAlgorithms is a collection of filtering and linear algebra algorithms for multidimensional arrays.
For algorithms that would typically apply along the columns of a matrix, you can instead pick an arbitrary axis (dimension).

Note that all functions come in two variants, a `!` version that uses pre-allocated output (where the output is
the first argument) and a version that allocates the output. Below, the `!` versions will be described.

### Tridiagonal and Woodbury inversion

If `F` is an LU-factorization of a tridiagonal matrix, or a [Woodbury matrix](WoodburyMatrices.jl) created from such a factorization,
then `A_ldiv_B_md!(dest, F, src, axis)` will solve the equation `F\b` for 1-dimensional slices
along dimension `axis`.
Unlike many linear algebra algorithms, this one is safe to use as a mutating algorithm with `dest=src`.
The tridiagonal case does not create temporaries, and it has excellent cache behavior.

### Matrix multiplication

Multiply a matrix `M` to all 1-dimensional slices along a particular dimension.
Here you have two algorithms to choose from:

- `A_mul_B_perm!(dest, M, src, axis)` uses `permutedims` and standard BLAS-accelerated routines; it allocates temporary storage.
- `A_mul_B_md!(dest, M, src, axis)` is a non-allocating naive routine. This also has optimized implementations for sparse `M` and 2x2 matrices.

In general it is very difficult to get efficient cache behavior for multidimensional multiplication, and often using `A_mul_B_perm!` is the best strategy.
However, there are cases where `A_mul_B_md!` is faster.
It's a good idea to time both and see which works better for your case.

_axes(F::Factorization, dim::Int) = hasmethod(axes, Tuple{typeof(F), Int}) ? axes(F, dim) : Base.OneTo(size(F, dim))
_axes(A::AbstractArray, dim::Int) = axes(A, dim)

"""
`A_ldiv_B_md!(dest, F, src, dim)` solves a tridiagonal system along dimension `dim` of `src`,
storing the result in `dest`. Currently, `F` must be an LU-factorized tridiagonal matrix.
If desired, you may safely use the same array for both `src` and `dest`, so that this becomes an
in-place algorithm.
"""
function A_ldiv_B_md!(dest, F, src, dim::Integer)
    1 <= dim <= max(ndims(dest),ndims(src)) || throw(DimensionMismatch("The chosen dimension $dim is larger than $(ndims(src)) and $(ndims(dest))"))
    ax = _axes(F, 1)
    ax == axes(src, dim) && ax == axes(dest, dim) || throw(DimensionMismatch("Axes $ax, $(axes(src,dim)), and $(axes(dest,dim)) do not match"))
    axes(dest) == axes(src) || throw(DimensionMismatch("Axes $(axes(dest)), $(axes(src)) do not match"))
    check_matrix(F)
    R1 = CartesianIndices(axes(dest)[1:dim-1])
    R2 = CartesianIndices(axes(dest)[dim+1:end])
    _A_ldiv_B_md!(dest, F, src, R1, R2)
end
_A_ldiv_B_md(F, src, R1::CartesianIndices, R2::CartesianIndices) =
    _A_ldiv_B_md!(similar(src, promote_type(eltype(F), eltype(src))), F, src, R1, R2)

# Solving along the first dimension
function _A_ldiv_B_md!(dest, F::LU{T,<:Tridiagonal{T}}, src,  R1::CartesianIndices{0}, R2::CartesianIndices) where {T}
    ax = _axes(F, 1)
    axbegin, axend = first(ax), last(ax)
    dl = F.factors.dl
    d  = F.factors.d
    du = F.factors.du
    # Forward substitution
    @inbounds for I2 in R2
        dest[axbegin, I2] = src[axbegin, I2]
        for i = axbegin+1:axend       # note: cannot use @simd here!
            dest[i, I2] = src[i, I2] - dl[i-1]*dest[i-1, I2]
        end
    end
    # Backward substitution
    dinv = 1 ./ d
    @inbounds for I2 in R2
        dest[axend, I2] /= d[axend]
        for i = axend-1:-1:axbegin  # note: cannot use @simd here!
            dest[i, I2] = (dest[i, I2] - du[i]*dest[i+1, I2])*dinv[i]
        end
    end
    dest
end

# Solving along any other dimension
function _A_ldiv_B_md!(dest, F::LU{T,<:Tridiagonal{T}}, src, R1::CartesianIndices, R2::CartesianIndices) where {T}
    ax = _axes(F, 1)
    axbegin, axend = first(ax), last(ax)
    dl = F.factors.dl
    d  = F.factors.d
    du = F.factors.du
    # Forward substitution
    @inbounds for I2 in R2
        @simd for I1 in R1
            dest[I1, axbegin, I2] = src[I1, axbegin, I2]
        end
        for i = axbegin+1:axend
            @simd for I1 in R1
                dest[I1, i, I2] = src[I1, i, I2] - dl[i-1]*dest[I1, i-1, I2]
            end
        end
    end
    # Backward substitution
    dinv = 1 ./ d
    for I2 in R2
        @simd for I1 in R1
            dest[I1, axend, I2] *= dinv[axend]
        end
        for i = axend-1:-1:axbegin
            @simd for I1 in R1
                dest[I1, i, I2] = (dest[I1, i, I2] - du[i]*dest[I1, i+1, I2])*dinv[i]
            end
        end
    end
    dest
end

function check_matrix(F::LU{T,<:Tridiagonal{T}}) where {T}
    ax = _axes(F, 1)
    for i in ax
        F.ipiv[i] == i || error("For efficiency, pivoting is not supported")
    end
    nothing
end

# Consider permutedims as an alternative to direct multiplication.
# Multiplication is an O(m*N) cost compared to an O(N) cost for tridiagonal algorithms.
# However, when the multiplication is only a small fraction of the total time
# (for example, when m is small), then these can be convenient and avoid the need for calls to permutedims.

# Multiplication using permutedims
"""
`A_mul_B_perm!(dest, M, src, dim)` computes `M*x` for slices `x` of `src` along dimension `dim`,
storing the result in `dest`. `M` must be an `AbstractMatrix`. This uses `permutedims` to make dimension
`dim` into the first dimension, performs a standard matrix multiplication, and restores the original
dimension ordering. In many cases, this algorithm exhibits the best cache behavior.
"""
function A_mul_B_perm!(dest, M::AbstractMatrix, src, dim::Integer)
    check_matmul_sizes(dest, M, src, dim)
    order = [dim; setdiff(1:ndims(src), dim)]
    srcp = permutedims(src, order)
    tmp = Array{eltype(dest), 2}(undef, size(dest, dim), div(length(dest), size(dest, dim)))
    mul!(tmp, M, reshape(srcp, (size(src,dim), div(length(srcp), size(src,dim)))))
    iorder = [2:dim; 1; dim+1:ndims(src)]
    permutedims!(dest, reshape(tmp, size(dest)[order]), iorder)
    dest
end

# Direct (temporary-free) multiplication
"""
`A_mul_B_md!(dest, M, src, dim)` computes `M*x` for slices `x` of `src` along dimension `dim`,
storing the result in `dest`. `M` must be an `AbstractMatrix`. This uses an in-place naive algorithm.
"""
function A_mul_B_md!(dest, M::AbstractMatrix, src, dim::Integer)
    check_matmul_sizes(dest, M, src, dim)
    if size(M,1) == size(M,2) == 1
        return mul!(dest, src, M[1,1])
    end
    R2 = CartesianIndices(size(dest)[dim+1:end])
    if dim > 1
        R1 = CartesianIndices(size(dest)[1:dim-1])
        _A_mul_B_md!(dest, M, src, R1, R2)
    else
        _A_mul_B_md!(dest, M, src, R2)
    end
end

# Multiplication along the first dimension
# Here we expect that M will typically be small and fit in cache, whereas src and dest do not
function _A_mul_B_md!(dest, M::AbstractMatrix, src, R2::CartesianIndices)
    m, n = size(M, 1), size(M, 2)
    if m == n == 2
        return _A_mul_B_md_2x2!(dest, M, src, R2)
    end
    for I2 in R2
        @inbounds for i = 1:m
            dest[i,I2] = zero(eltype(dest))
        end
        @inbounds for j = 1:n
            b = src[j,I2]
            @simd for i = 1:m
                dest[i,I2] += M[i,j]*b
            end
        end
    end
    dest
end
_A_mul_B_md(M::AbstractMatrix, src, R2::CartesianIndices) = _A_mul_B_md!(alloc_matmul(M, src, 1), M, src, R2)

function _A_mul_B_md_2x2!(dest, M::AbstractMatrix, src, R2::CartesianIndices)
    a, b, c, d = M[1,1], M[1,2], M[2,1], M[2,2]
    @simd for I2 in R2
        @inbounds begin
            s1, s2 = src[1,I2], src[2,I2]
            dest[1,I2] = a*s1 + b*s2
            dest[2,I2] = c*s1 + d*s2
        end
    end
    dest
end

function _A_mul_B_md!(dest, M::SparseMatrixCSC, src, R2::CartesianIndices)
    m, n = size(M,1), size(M,2)
    nzv = M.nzval
    rv = M.rowval
    cp = M.colptr
    for I2 in R2
        @inbounds for i = 1:m
            dest[i,I2] = zero(eltype(dest))
        end
        for j = 1:n
            b = src[j,I2]
            @inbounds for k = cp[j]:(cp[j+1]-1)
                dest[rv[k],I2] += nzv[k]*b
            end
        end
    end
    dest
end

# Multiplication along any other dimension
function _A_mul_B_md!(dest, M::AbstractMatrix, src,  R1::CartesianIndices, R2::CartesianIndices)
    m, n = size(M, 1), size(M, 2)
    if m == n == 2
        return _A_mul_B_md_2x2!(dest, M, src, R1, R2)
    end
    fill!(dest, zero(eltype(dest)))
    for I2 in R2
        for j = 1:n
            @inbounds for i = 1:m
                Mij = M[i,j]
                @simd for I1 in R1
                    dest[I1,i,I2] += Mij*src[I1,j,I2]
                end
            end
        end
    end
    dest
end
_A_mul_B_md(M::AbstractMatrix, src,  R1::CartesianIndices, R2::CartesianIndices) = _A_mul_B_md!(alloc_matmul(M, src, ndims(R1)+1), M, src, R1, R2)

function _A_mul_B_md_2x2!(dest, M::AbstractMatrix, src,  R1::CartesianIndices, R2::CartesianIndices)
    a, b, c, d = M[1,1], M[1,2], M[2,1], M[2,2]
    for I2 in R2
        @simd for I1 in R1
            @inbounds begin
                s1, s2 = src[I1,1,I2], src[I1,2,I2]
                dest[I1,1,I2] = a*s1 + b*s2
                dest[I1,2,I2] = c*s1 + d*s2
            end
        end
    end
    dest
end

function _A_mul_B_md!(dest, M::SparseMatrixCSC, src, R1::CartesianIndices, R2::CartesianIndices)
    m, n = size(M,1), size(M,2)
    nzv = M.nzval
    rv = M.rowval
    cp = M.colptr
    fill!(dest, zero(eltype(dest)))
    for I2 in R2
        for j = 1:n
            @inbounds for k = cp[j]:(cp[j+1]-1)
                i, Mij = rv[k], nzv[k]
                @simd for I1 in R1
                    dest[I1,i,I2] += Mij*src[I1,j,I2]
                end
            end
        end
    end
    dest
end

function check_matmul_sizes(dest, M::AbstractMatrix, src, dim)
    1 <= dim <= max(ndims(dest),ndims(src)) || throw(DimensionMismatch("The chosen dimension $dim is larger than $(ndims(src)) and $(ndims(dest))"))
    m, n = size(M, 1), size(M, 2)
    n == size(src, dim) && m == size(dest, dim) || throw(DimensionMismatch("Sizes $m, $n, $(size(src,dim)), and $(size(dest,dim)) do not match"))
    for i = 1:max(ndims(src), ndims(dest))
        i == dim && continue
        if size(src,i) != size(dest,i)
            throw(DimensionMismatch("Sizes $(size(dest)), $(size(src)) do not match"))
        end
    end
    nothing
end

using WoodburyMatrices
using Test

@testset "Woodbury" begin
    d  = 2 .+ rand(5)
    dl = -rand(4)
    du = -rand(4)
    M = Tridiagonal(dl, d, du)
    F = lu(M)
    U = sprand(5,2,0.2)
    V = sprand(2,5,0.2)
    C = rand(2,2)
    W = Woodbury(F, U, C, V)

    src = rand(5, 8)
    @test W\src ≈ AxisAlgorithms.A_ldiv_B_md(W, src, 1)
    src = rand(5, 5, 5, 5)
    for dim = 1:4
        dest1 = mapslices(x->W\x, copy(src), dims=dim)
        dest2 = similar(src)
        AxisAlgorithms.A_ldiv_B_md!(dest2, W, src, dim)
        @test dest1 ≈ dest2
    end
end

using Test, OffsetArrays

@testset "Tridiag" begin
    d  = 2 .+ rand(5)
    dl = rand(4)
    du = rand(4)
    M = Tridiagonal(dl, d, du)
    F = lu(M)
    src = rand(5,5,5)
    for dim = 1:3
        dest1 = mapslices(x->ldiv!(F, x), copy(src), dims=dim)
        dest2 = similar(src)
        AxisAlgorithms.A_ldiv_B_md!(dest2, F, src, dim)
        @test dest1 ≈ dest2
    end

    src = OffsetArray(src, -2:2, 1:5, 0:4)
    dest1 = mapslices(x->ldiv!(F, x), copy(src), dims=2)
    dest2 = similar(src)
    AxisAlgorithms.A_ldiv_B_md!(dest2, F, src, 2)
    @test dest1 ≈ dest2
end

function _A_ldiv_B_md!(dest, W::Woodbury, src,  R1, R2)
    _A_ldiv_B_md!(dest, W.A, src, R1, R2)
    tmp1 = _A_mul_B_md(W.V, dest, R1, R2)
    tmp2 = _A_mul_B_md(W.Cp, tmp1, R1, R2)
    tmp3 = _A_mul_B_md(W.U, tmp2, R1, R2)
    # TODO?: would be nice to fuse the next two steps
    tmp4 = _A_ldiv_B_md(W.A, tmp3, R1, R2)
    sub!(dest, tmp4)
end

function sub!(A, B)
    for I in eachindex(A, B)
        A[I] -= B[I]
    end
    A
end

check_matrix(W::Woodbury) = check_matrix(W.A)

using AxisAlgorithms
using Test

@testset "matmul" begin
    n = 5
    m = 3
    src = rand(n,n,n)
    for M in (rand(m,n), sprand(m,n,0.2))
        for dim = 1:3
            dest1 = mapslices(b->M*b, src, dims=dim)
            sz = fill(n,3)
            sz[dim] = m
            dest2 = rand(sz...)
            AxisAlgorithms.A_mul_B_md!(dest2, M, src, dim)
            @test dest1 ≈ dest2
            if !issparse(M)
                rand!(dest2)
                AxisAlgorithms.A_mul_B_perm!(dest2, M, src, dim)
                @test dest1 ≈ dest2
            end
        end
    end

    # Test size-checking
    for dim = 1:3
        M = sprand(m,n,0.2)
        dest1 = mapslices(b->M*b, src, dims=dim)
        sz = fill(n,3)
        sz[dim] = m+1
        dest2 = rand(sz...)
        @test_throws DimensionMismatch AxisAlgorithms.A_mul_B_md!(dest2, M, src, dim)
        @test_throws DimensionMismatch AxisAlgorithms.A_mul_B_perm!(dest2, M, src, dim)
        sz[dim] = m
        sz[mod1(dim+1,3)] = 1
        dest2 = rand(sz...)
        @test_throws DimensionMismatch AxisAlgorithms.A_mul_B_md!(dest2, M, src, dim)
        @test_throws DimensionMismatch AxisAlgorithms.A_mul_B_perm!(dest2, M, src, dim)
    end

    # Test 1x1 and 2x2 cases
    n = 5
    for dim = 1:3
        sz = fill(n,3)
        sz[dim] = 1
        src2 = rand(sz...)
        M = fill(3.2,1,1)
        dest1 = mapslices(b->M*b, src2, dims=dim)
        dest2 = AxisAlgorithms.A_mul_B_md(M, src2, dim)
        @test dest1 ≈ dest2
        sz[dim] = 2
        src2 = rand(sz...)
        M = rand(2,2)
        dest1 = mapslices(b->M*b, src2, dims=dim)
        dest2 = AxisAlgorithms.A_mul_B_md(M, src2, dim)
        @test dest1 ≈ dest2
    end
end

module AxisAlgorithms

using WoodburyMatrices
using LinearAlgebra, SparseArrays

export A_ldiv_B_md!,
    A_ldiv_B_md,
    A_mul_B_md!,
    A_mul_B_md,
    A_mul_B_perm!,
    A_mul_B_perm

"""
`A_ldiv_B_md(F, src, dim)` solves `F\b` for slices `b` of `src` along dimension `dim`,
storing the result along the same dimension of the output.
Currently, `F` must be an LU-factorized tridiagonal matrix or a Woodbury matrix.
"""
A_ldiv_B_md(F, src, dim::Integer) = A_ldiv_B_md!(similar(src), F, src, dim)

"""
`A_mul_B_md(M, src, dim)` computes `M*x` for slices `x` of `src` along dimension `dim`,
storing the resulting vector along the same dimension of the output.
`M` must be an `AbstractMatrix`. This uses an in-place naive algorithm.
"""
A_mul_B_md(M::AbstractMatrix, src, dim::Integer) = A_mul_B_md!(alloc_matmul(M,src,dim), M, src, dim)

"""
`A_mul_B_perm(M, src, dim)` computes `M*x` for slices `x` of `src` along dimension `dim`, storing the
resulting vector along the same dimension of the output.
`M` must be an `AbstractMatrix`. This uses `permutedims` to make dimension
`dim` into the first dimension, performs a standard matrix multiplication, and restores the original
dimension ordering. In many cases, this algorithm exhibits the best cache behavior.
"""
A_mul_B_perm(M::AbstractMatrix, src, dim::Integer) = A_mul_B_perm!(alloc_matmul(M,src,dim), M, src, dim)

function alloc_matmul(M,src::AbstractArray{S,N},dim) where {S,N}
    sz = [size(src)...]
    sz[dim] = size(M,1)
    T = Base.promote_op(*, eltype(M), S)
    Array{T,N}(undef, sz...)
end

include("tridiag.jl")
include("matmul.jl")
include("woodbury.jl")

end # module
